//+------------------------------------------------------------------+
//|                                         Dolly (the famous sheep) |
//|               original indicator is called valasholic13 v2.5.mq4 |
//|                                                                  |
//|                  and the original author is valasholic@yahoo.com |
//|                                                                  |         
//|                        mods and stuff by Linuxser for Forex-TSD  |
//|                      (there is a lot of usefull code inside here)|
//|Credits: hulahula (traslation from original indonesian language)  |
//|ign... in collaboration with Linuxser (with mods and improvments  |
//+------------------------------------------------------------------+

/*
Changelog v0.4.1:
   - Modifications over the pivot points drawing: I think now is better
     and more clean code in that section. With this mod, also the
     pivots, supports and resistances are only calculated if and only
     if the flag pivotlines is set true.
     Other modifications here are about the object creation. With this
     improve the objects are created at init time and isn't necessary
     to create them at any time.
   - User experience: this is a conflictive point... I've modified some
     graphics issues to get a more readeable indicator.
       * "Unions" between zones of diferent days.
       * Realistic font size.
   - Corrections in the source coude... now it's a little more beauty (sorry for
     the little spanish comments)     
     
Changelog v0.4.2:
   - Comments modified (linuxser)
   - Added buy/sell zones just like the WSS indicator. (ign...)
   - Added a parameter to back to old style (without zones... ) Note: when
     the parameter ShowZones is off (false), then the objects are deleted to
     'improve' speed :) (ign...)
   - More improvements on PivotPoints add-on (object creation). (ign...)
   
*/
#property copyright ""
#property link      ""

#define IND_NAME "Dolly v0.4.2"
#define LEVEL_1 20
#define LEVEL_2 40
#define LEVEL_3 55

#property indicator_chart_window
//#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  Snow
#property indicator_width1 0
#property indicator_color2  Red
#property indicator_width2 2
#property indicator_color3  Blue
#property indicator_width3 2
#property indicator_color4  Orange
#property indicator_width4 2
#property indicator_color5  SteelBlue
#property indicator_width5 2
#property indicator_color6  Yellow
#property indicator_width6 1
#property indicator_color7  Aqua
#property indicator_width7 1
//---- input parameters

extern bool ShowPivotLines = false;
extern bool ShowZones = false;
//extern int  BrokerGMTOffset = 0;
extern bool onscreen = true;
//extern bool dynamic = true;
extern color lineletters = LimeGreen;

//---- buffers
double PBuffer[];
double J1Buffer[];
double B1Buffer[];
double J2Buffer[];
double B2Buffer[];
double J3Buffer[];
double B3Buffer[];
string Pivot = "Pivot Point", Jual1 = "S 1", Beli1 = "R 1";
string Jual2="S 2", Beli2="R 2", Jual3="S 3", Beli3="R 3";
extern int fontsize = 8;
double P, J1, B1, J2, B2, J3, B3;
double LastHigh, LastLow, x;
double D4=0.55;

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{

   ObjectDelete("Pivot");
	ObjectDelete("Jual1");
	ObjectDelete("Beli1");
	ObjectDelete("Jual2");
	ObjectDelete("Beli2");
	ObjectDelete("Jual3");
	ObjectDelete("Beli3");   

	deinit_pivots();
	deinit_zones();
	//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	//---- indicator line
	SetIndexStyle(0, DRAW_LINE);
	SetIndexStyle(1, DRAW_LINE);
	SetIndexStyle(2, DRAW_LINE);
	SetIndexStyle(3, DRAW_LINE);
	SetIndexStyle(4, DRAW_LINE);
	SetIndexStyle(5, DRAW_LINE);
	SetIndexStyle(6, DRAW_LINE);
	SetIndexBuffer(0, PBuffer);
	SetIndexBuffer(1, J1Buffer);
	SetIndexBuffer(2, B1Buffer);
	SetIndexBuffer(3, J2Buffer);
	SetIndexBuffer(4, B2Buffer);
	SetIndexBuffer(5, J3Buffer);
	SetIndexBuffer(6, B3Buffer);
	//---- name for DataWindow and indicator subwindow label
	IndicatorShortName(IND_NAME);
	//SetIndexLabel(0, "Pivot Point");
	//----
	SetIndexDrawBegin(0,1);
	IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
	
	ObjectCreate("Pivot", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Pivot", "PIVOT/SL+SP", fontsize, "Arial", lineletters);
	ObjectCreate("Jual1", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Jual1", "SELL AREA", fontsize, "Arial", lineletters);
	ObjectCreate("Beli1", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Beli1", "BUY AREA", fontsize, "Arial", lineletters);
	ObjectCreate("Jual2", OBJ_TEXT, 0, 0, 0); 
	ObjectSetText("Jual2", "1st SELL TARGET (take profit), BREAK LOW, ", fontsize, "Arial", lineletters);
	ObjectCreate("Beli2", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Beli2", "1st BUY TARGET (take profit) BREAK HIGH", fontsize, "Arial", lineletters);
	ObjectCreate("Jual3", OBJ_TEXT, 0, 0, 0);
	ObjectSetText("Jual3", "2nd TARGET", fontsize, "Arial", lineletters);
	ObjectCreate("Beli3", OBJ_TEXT, 0, 0, 0); 
	ObjectSetText("Beli3", "2nd TARGET", fontsize, "Arial", lineletters);


   if(ShowPivotLines)
      init_pivots();
      
   if(ShowZones)
      init_zones();
	//----
	return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	int counted_bars = IndicatorCounted();
	int limit, i;

	//---- indicator calculation
	if(counted_bars == 0)
	{
		x = Period();
		if(x > 240) 
			return(-1);

		///////////To Make a Line for SELL/BUY \\\\\\\\\\\\\

	}
	if(counted_bars < 0) 
		return(-1);
	//---- last counted bar will be recounted
	//   if(counted_bars>0) counted_bars--;
	limit = (Bars - counted_bars) - 1;
	//----
	for(i = limit; i >= 0; i--)
	{ 
		if(High[i+1] > LastHigh) 
			LastHigh = High[i+1];
		//----
		if(Low[i+1] < LastLow) 
			LastLow=Low[i+1];
		if(TimeDay(Time[i]) != TimeDay(Time[i+1]))
		{
		   PBuffer[i+1] = EMPTY_VALUE;
		   J1Buffer[i+1] = EMPTY_VALUE;
		   B1Buffer[i+1] = EMPTY_VALUE;
		   J2Buffer[i+1] = EMPTY_VALUE;
		   B2Buffer[i+1] = EMPTY_VALUE;
		   J3Buffer[i+1] = EMPTY_VALUE;
		   B3Buffer[i+1] = EMPTY_VALUE;
			//////////// Logic for determinate Momentum Break \\\\\\\\\\\\\\\\\\\\\

			P = (LastHigh + LastLow + Close[i+1]) / 3; // Logic for determinating pivot
			B1 = P + LEVEL_1 * Point; // Logic to determinate Buy Area (Can be change as you analize)
			J1 = P - LEVEL_1 * Point; // Logic to determinate Sell Area (Can be change as you analize)
			B2 = P + LEVEL_2 * Point; // Logic to determinate High Break Area (Can be change as you analize)
			J2 = P - LEVEL_2 * Point; // Logic to determinate Low Break Area (Can be change as you analize)
			B3 = P + LEVEL_3 * Point; // Logic to determinate High Target Area (Can be change as you analize)
			J3 = P - LEVEL_3 * Point; // Logic to determinate Low Target Area (Can be change as you analize)
			
			//Lo usa para calcular los pivotes... no deberia ser Low[] y High[]???
			LastLow = Open[i]; 
			LastHigh = Open[i];
			
         ObjectMove("Pivot", 0, Time[i], P);
         ObjectMove("Jual1", 0, Time[i], J1);
         ObjectMove("Beli1", 0, Time[i], B1);
         ObjectMove("Jual2", 0, Time[i], J2);
         ObjectMove("Beli2", 0, Time[i], B2);
         ObjectMove("Jual3", 0, Time[i], J3);
         ObjectMove("Beli3", 0, Time[i], B3);
         
         if( ShowZones && TimeDayOfYear(Time[i]) == DayOfYear())
         {
            if( ObjectFind("Neutral_0") == -1 )
               init_zones();
            move_zones(i, J1, J2, J3, B1,B2, B3);
         }
		}
		PBuffer[i] = P;
		J1Buffer[i] = J1;
		B1Buffer[i] = B1;
		J2Buffer[i] = J2;
		B2Buffer[i] = B2;
		J3Buffer[i] = J3;
		B3Buffer[i] = B3;



		if (ShowPivotLines==true)
		{
		    //---- Saca maximos y minimos para calcular los pivotes.
		    //-- Despues tengo que leer bien esto ya que es lo que se deberia usar en un principio
		    double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
		    ArrayCopyRates(rates, Symbol(), PERIOD_D1);

		    if(DayOfWeek() == 1)
		    {
			    if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
			    {
				    yesterday_close = rates[1][4];
				    yesterday_high = rates[1][3];
				    yesterday_low = rates[1][2];
			    }
			    else
			    {
				    for(int d = 5;d>=0;d--)
				    {
					    if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
					    {
						    yesterday_close = rates[d][4];
						    yesterday_high = rates[d][3];
						    yesterday_low = rates[d][2];
						    break;
					    }
				    }  
			    }
		    }
		    else
		    {
			    yesterday_close = rates[1][4];
			    yesterday_high = rates[1][3];
			    yesterday_low = rates[1][2];
		    }
			//---- Calculate Pivots
			double R = yesterday_high - yesterday_low;//range
			double p = ( yesterday_high + yesterday_low + yesterday_close ) / 3;// Standard Pivot
			double r3 = ( 2 * p ) + ( yesterday_high - ( 2 * yesterday_low ));
			double r2 = p + ( yesterday_high - yesterday_low );
			double r1 = ( 2 * p ) - yesterday_low;
			double s1 = ( 2 * p ) - yesterday_high;
			double s2 = p - ( yesterday_high - yesterday_low );
			double s3 = ( 2 * p ) - ( ( 2 * yesterday_high ) - yesterday_low );

         if(ObjectFind("p_Line") == -1)
            init_pivots();
         set_pivots(p, r1, r2, r3, s1, s2, s3);
		}

		if (onscreen==true) 

			Comment (
			       "\n        " + IND_NAME + " ( BREAKOUT STRATEGY ) "
					+"\n -------------------------------------------------------------------"
					+"\n BUY AREA (break) :"
					+"\n -------------------------------------------------------------------"
					+"\n FIRST BUY STOP  "+Symbol()+" TO "+(DoubleToStr (B1Buffer[i],Digits))
					+"\n SECOND BUY STOP  "+Symbol()+" TO "+(DoubleToStr(B2Buffer[i],Digits))					
					+"\n STOP LOSS Conservative "+(DoubleToStr (PBuffer[i]-(6*Point),Digits))
					+"\n STOP LOSS Risky "+(DoubleToStr(B1Buffer[i],Digits))	
					+"\n INITIAL TAKE PROFIT "+(DoubleToStr ((B2Buffer[i]),Digits))
					+"\n SECONDARY TAKE PROFIT "+(DoubleToStr ((B3Buffer[i]),Digits))
					+"\n "
					+"\n -------------------------------------------------------------------"
					+"\n \n SELL AREA (break) :"
					+"\n -------------------------------------------------------------------"
					+"\n FIRST SELL STOP  "+Symbol()+" TO "+(DoubleToStr (J1Buffer[i],Digits))					
					+"\n SECOND SELL STOP  "+Symbol()+" TO "+(DoubleToStr (J2Buffer[i],Digits))
					+"\n STOP LOSS Conservative"+(DoubleToStr (PBuffer[i]+(6*Point),Digits))
					+"\n STOP LOSS Risky"+(DoubleToStr(B1Buffer[i],Digits))		
					+"\n INITIAL TAKE PROFIT "+(DoubleToStr ((J2Buffer[i]),Digits))
					+"\n SECONDARY TAKE PROFIT "+(DoubleToStr ((J3Buffer[i]),Digits))
					+"\n "			
					+"\n -------------------------------------------------------------------"
					+"\n POSSIBLE PROJECTIONS AND REVERSAL LEVELS "
					+"\n (USE WITH CAUTION) "
					+"\n -------------------------------------------------------------------"
					+"\n LOWER CORRECTION :"
					+"\n # TARGET/BUY LIMIT  "+Symbol()+" TO "+(DoubleToStr(PBuffer[i]-(89*Point),Digits))
					+"\n # TARGET/BUY LIMIT  "+Symbol()+" TO "+(DoubleToStr(PBuffer[i]-(144*Point),Digits))					
					+"\n \n UPPER CORRECTION :"
					+"\n # TARGET/SELL LIMIT  "+Symbol()+" TO "+(DoubleToStr(PBuffer[i]+(89*Point),Digits))
					+"\n # TARGET/SELL LIMIT  "+Symbol()+" TO "+(DoubleToStr(PBuffer[i]+(144*Point),Digits))					
					+"\n -------------------------------------------------------------------");


		//HOW TO MAKE THE PRICE LINE OF THE SUPPORT & RESISTANT APPEAR?
		//WAITING FOR NEXT TIP & UP DATE


	}

	//----
	return(0);

}
//+------------------------------------------------------------------+

void init_pivots()
{
	ObjectCreate("p_Line", OBJ_HLINE,0, 0,0);
	ObjectSet("p_Line",OBJPROP_COLOR,DeepPink);
	ObjectSet("p_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("r1_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("r1_Line",OBJPROP_COLOR,Yellow);
	ObjectSet("r1_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("r2_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("r2_Line",OBJPROP_COLOR,Orange);
	ObjectSet("r2_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("r3_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("r3_Line",OBJPROP_COLOR,Red);
	ObjectSet("r3_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("s1_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("s1_Line",OBJPROP_COLOR,Yellow);
	ObjectSet("s1_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("s2_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("s2_Line",OBJPROP_COLOR,Orange);
	ObjectSet("s2_Line",OBJPROP_STYLE,STYLE_SOLID);

	ObjectCreate("s3_Line", OBJ_HLINE,0, 0, 0);
	ObjectSet("s3_Line",OBJPROP_COLOR,Red);
	ObjectSet("s3_Line",OBJPROP_STYLE,STYLE_SOLID);

	// --- Typing Labels
	if(ObjectFind("R3 label") != 0)
	{
		ObjectCreate("R3 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("R3 label", " R3 ", 8, "Arial", Red);
	}

	if(ObjectFind("S3 label") != 0)
	{
		ObjectCreate("S3 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("S3 label", " S3 ", 8, "Arial", Red);
	}

	if(ObjectFind("R2 label") != 0)
	{
		ObjectCreate("R2 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("R2 label", " R2 ", 8, "Arial", Orange);
	}

	if(ObjectFind("S2 label") != 0)
	{
		ObjectCreate("S2 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("S2 label", " S2 ", 8, "Arial", Orange);
	}

	if(ObjectFind("R1 label") != 0)
	{
		ObjectCreate("R1 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("R1 label", " R1 ", 8, "Arial", Yellow);
	}

	if(ObjectFind("S1 label") != 0)
	{
		ObjectCreate("S1 label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("S1 label", " S1 ", 8, "Arial", Yellow);
	}

	if(ObjectFind("P label") != 0)
	{
		ObjectCreate("P label", OBJ_TEXT, 0, 0, 0);
		ObjectSetText("P label", " Pivot ", 8, "Arial", DeepPink);
	}
	return;
}

void set_pivots(double p, double r1, double r2, double r3, double s1, double s2, double s3)
{
   ObjectSet("p_Line",OBJPROP_PRICE1, p);   ObjectMove("P label",  0, Time[0], p);
   ObjectSet("r1_Line",OBJPROP_PRICE1, r1); ObjectMove("R1 label", 0, Time[0], r1);
   ObjectSet("r2_Line",OBJPROP_PRICE1, r2); ObjectMove("R2 label", 0, Time[0], r2);
   ObjectSet("r3_Line",OBJPROP_PRICE1, r3); ObjectMove("R3 label", 0, Time[0], r3);
   ObjectSet("s1_Line",OBJPROP_PRICE1, s1); ObjectMove("S1 label", 0, Time[0], s1);
   ObjectSet("s2_Line",OBJPROP_PRICE1, s2); ObjectMove("S2 label", 0, Time[0], s2);
   ObjectSet("s3_Line",OBJPROP_PRICE1, s3); ObjectMove("S3 label", 0, Time[0], s3);
   
}

void deinit_pivots()
{
	ObjectDelete("r1 Label");
	ObjectDelete("r1_Line");
	ObjectDelete("r2 Label");
	ObjectDelete("r2_Line");
	ObjectDelete("r3 Label");
	ObjectDelete("r3_Line");
	ObjectDelete("r1 Label");
	ObjectDelete("r1_Line");
	ObjectDelete("r2 Label");
	ObjectDelete("r2_Line");
	ObjectDelete("r3 Label");
	ObjectDelete("r3_Line");
	ObjectDelete("R1 Label");
	ObjectDelete("R1_Line");
	ObjectDelete("R2 Label");
	ObjectDelete("R2_Line");
	ObjectDelete("R3 Label");
	ObjectDelete("R3_Line");
	ObjectDelete("S1 Label");
	ObjectDelete("S1_Line");
	ObjectDelete("S2 Label");
	ObjectDelete("S2_Line");
	ObjectDelete("S3 Label");
	ObjectDelete("S3_Line");
	ObjectDelete("P Label");
	ObjectDelete("P_Line");
}

void
init_zones()
{
   int i;
   for(i = 0; i < (LEVEL_1 *2 /2); i++)
   {
      ObjectCreate( "Neutral_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Neutral_"+i, OBJPROP_COLOR, White);
      ObjectSet("Neutral_"+i, OBJPROP_WIDTH, 1);
   }
   
   for(i = 0; i < (LEVEL_2 / 2); i++)
   {
      ObjectCreate( "Buy1_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Buy1_"+i, OBJPROP_COLOR, Blue);
      ObjectSet("Buy1_"+i, OBJPROP_WIDTH, 1);
      
      ObjectCreate( "Sell1_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Sell1_"+i, OBJPROP_COLOR, Red);
      ObjectSet("Sell1_"+i, OBJPROP_WIDTH, 1);
   }
   
   for(i = 0; i < (LEVEL_2 *2 /2); i++)
   {
      ObjectCreate( "Buy2_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Buy2_"+i, OBJPROP_COLOR, SteelBlue);
      ObjectSet("Buy2_"+i, OBJPROP_WIDTH, 1);
      
      ObjectCreate( "Sell2_"+i, OBJ_TREND, 0, 0, 0);
      ObjectSet("Sell2_"+i, OBJPROP_COLOR, Orange);
      ObjectSet("Sell2_"+i, OBJPROP_WIDTH, 1);
   }
}

void // J's < B's
move_zones(int time, double J1, double J2, double J3, double B1, double B2, double B3)
{
   int periods_by_day = (60*24)/ Period();
   int i, obj_num;
   
   for(i = 0; i < (B1 - J1) / Point; i += 2)
   {
      obj_num = i / 2;
      
      ObjectSet("Neutral_"+obj_num, OBJPROP_PRICE1, J1 + i * Point);
      ObjectSet("Neutral_"+obj_num, OBJPROP_PRICE2, J1 + i * Point);
      ObjectSet("Neutral_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Neutral_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Neutral_"+obj_num, OBJPROP_BACK, true);
   }
   
   for(i = 0; i < (J1 - J2) / Point; i += 2)
   {
      obj_num = i / 2;
      
      ObjectSet("Buy1_"+obj_num, OBJPROP_PRICE1, B1 + i * Point);
      ObjectSet("Buy1_"+obj_num, OBJPROP_PRICE2, B1 + i * Point);
      ObjectSet("Buy1_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Buy1_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Buy1_"+obj_num, OBJPROP_BACK, true);
      
      ObjectSet("Sell1_"+obj_num, OBJPROP_PRICE1, J1 - i * Point);
      ObjectSet("Sell1_"+obj_num, OBJPROP_PRICE2, J1 - i * Point);
      ObjectSet("Sell1_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Sell1_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Sell1_"+obj_num, OBJPROP_BACK, true);
   }
   
   for(i = 0; i < (J2 - J3) / Point; i += 2)
   {
      obj_num = i / 2;
      
      ObjectSet("Buy2_"+obj_num, OBJPROP_PRICE1, B2 + i * Point);
      ObjectSet("Buy2_"+obj_num, OBJPROP_PRICE2, B2 + i * Point);
      ObjectSet("Buy2_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Buy2_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Buy2_"+obj_num, OBJPROP_BACK, true);
      
      ObjectSet("Sell2_"+obj_num, OBJPROP_PRICE1, J2 - i * Point);
      ObjectSet("Sell2_"+obj_num, OBJPROP_PRICE2, J2 - i * Point);
      ObjectSet("Sell2_"+obj_num, OBJPROP_TIME1, Time[time]);
      ObjectSet("Sell2_"+obj_num, OBJPROP_TIME2, Time[time]+ 3600 * 24);
      ObjectSet("Sell2_"+obj_num, OBJPROP_BACK, true);
   }
}

void
deinit_zones()
{
   int i;
   for(i = 0; i < (LEVEL_1 *2 /2); i++)
      ObjectDelete( "Neutral_"+i);
 
   
   for(i = 0; i < (LEVEL_2 / 2); i++)
   {
      ObjectDelete( "Buy1_"+i);
      ObjectDelete( "Sell1_"+i);

   }
   
   for(i = 0; i < (LEVEL_2 *2 /2); i++)
   {
      ObjectDelete( "Buy2_"+i);
      ObjectDelete( "Sell2_"+i);
   }
}